;;; navi2ch-mona.el --- Mona Font Utils for Navi2ch

;; Copyright (C) 2001 by 2$B$A$c$s$M$k(B

;; Author: (not 1)
;; 431 $B$NL>L5$7$5$s(B

;; Keywords: 2ch, network

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; (require 'navi2ch-mona)
;; (add-hook 'navi2ch-article-arrange-message-hook
;;           'navi2ch-mona-arrange-message)
;; (setq navi2ch-mona-enable t)
;; $B$9$l$P<h$j4:$($:$*$C$1!#(B          


;;; Code:

(require 'navi2ch-article)

(defvar navi2ch-mona-enable nil
  "mona $B%U%)%s%H$r;HMQ$9$k$+$I$&$+(B")
(defvar navi2ch-mona-enable-board-list nil
  "mona $B%U%)%s%H$r;HMQ$9$kHD$N%j%9%H(B.")
(defvar navi2ch-mona-disable-board-list nil
  "mona $B%U%)%s%H$r;HMQ$7$J$$HD$N%j%9%H(B")
(defvar navi2ch-mona-pack-space-p nil
  "2$B$D0J>e$N6uGr$r$^$H$a$k$+(B")
(defvar navi2ch-mona-font "-mona-gothic-medium-r-*--16-*-p-*")

;; mona $BMQ$N(B face $B$r:n@.!#(B
(make-face 'navi2ch-mona-face)
(set-face-font 'navi2ch-mona-face navi2ch-mona-font)

;; face $B$,FC$K;XDj$5$l$F$$$J$$ItJ,$r(B mona-face $B$K$9$k(B
(defun navi2ch-mona-put-face ()
  (save-excursion
    (goto-char (point-min))
    (let (p)
      (while (not (eobp))
        (setq p (next-single-property-change (point)
                                             'face nil (point-max)))
        (unless (get-text-property (point) 'face)
          (put-text-property (point) (1- p)
                             'face 'navi2ch-mona-face))
        (goto-char p)))))

(defun navi2ch-mona-pack-space ()
  (save-excursion
    (goto-char (point-min))
    (while (re-search-forward "^ +" nil t)
      (replace-match ""))
    (goto-char (point-min))
    (while (re-search-forward"  +" nil t)
      (replace-match " "))))

(defun navi2ch-mona-arrange-message ()
  (let ((id (cdr (assq 'id navi2ch-article-current-board))))
    (when (or (member id navi2ch-mona-enable-board-list)
              (and (not (member id navi2ch-mona-disable-board-list))
                   navi2ch-mona-enable))
      (navi2ch-mona-put-face))
    (when navi2ch-mona-pack-space-p
      (navi2ch-mona-pack-space))))

(provide 'navi2ch-mona)

;;; navi2ch-mona.el ends here